program dinamic_stack;
uses crt;
const stack_max=5;
type stack_type=array[1..stack_max] of integer;
procedure menu;
  begin
    writeln('1-dobavit v stack');
    writeln('2-izvlech iz stecka');
    writeln('3-ochistit stack');
    writeln('4-vivesti stack na ekran');
    writeln('5-Bb|XOd');
  end;
procedure add(var stack:stack_type; user:boolean; new_value:integer; var elements_count:integer; var f:text);
  begin
    if (elements_count>=stack_max)
    then
      begin
        if (user)
        then
          begin
            writeln('Stack zapolnen. press enter');
            readln;
          end
        else
          begin
            writeln(f,'overflow');
          end;
      end
    else
      begin
        elements_count:=elements_count+1;
        stack[elements_count]:=new_value;
        if (not user)
        then
          begin
            writeln(f,'ok');
          end;
      end;
  end;
procedure delete_element(var stack:stack_type; user:boolean; var elements_count:integer; var f:text);
  begin
    if (elements_count>0)
    then
      begin
        if (user)
        then
          begin
            writeln('element: ',stack[elements_count]);
            writeln('Press enter');
            readln;
          end
        else
          begin
            writeln(f,'ok ',stack[elements_count]);
          end;
        elements_count:=elements_count-1;
      end
    else
      begin
        if (user)
        then
          begin
            writeln('Stack uje pust. Press enter.');
            readln;
          end
        else
          begin
            writeln(f,'empty');
          end;
      end;
  end;
procedure clear_stack(var stack:stack_type; user:boolean; var elements_count:integer; var f:text);
  begin
    elements_count:=0;
    if (not user)
    then
      begin
        writeln(f,'ok');
      end;
  end;
procedure print(stack:stack_type; user:boolean; elements_count:integer; var f:text);
var i:integer;
  begin
    if (elements_count<1)
    then
      begin
        if (user)
        then
          begin
            writeln('Stack pust. press enter');
            readln;
          end
        else
          begin
            writeln(f,'');
          end;
      end
    else
      begin
        if (user)
        then
          begin
            for i:=1 to elements_count do
              begin
                write(stack[i],' ');
              end;
            writeln;
            writeln('press enter');
            readln;
          end
        else
          begin
            for i:=1 to elements_count do
              begin
                write(f,stack[i],' ');
              end;
            writeln(f);
          end;
      end
  end;
procedure user_interface;
var action_code,new_value,elements_count:integer;
    user:boolean;
    stack:stack_type;
    var f:text;
  begin
    user:=TRUE;
    elements_count:=0;
    repeat
      clrscr;
      menu;
      writeln('action code:');
      readln(action_code);
      case action_code of
      1:begin
          write('value=');
          readln(new_value);
          add(stack,user,new_value,elements_count,f);
        end;
      2:delete_element(stack,user,elements_count,f);
      3:clear_stack(stack,user,elements_count,f);
      4:print(stack,user,elements_count,f);
      end;
    until (action_code=5);
  end;
procedure file_interface(read_file,write_file:string);
var user:boolean;
    elements_count,p,parametr:integer;
    f,f2:text;
    s,action,parametr_string:string;
    stack:stack_type;
  begin
    elements_count:=0;
    user:=FALSE;
    assign(f2,read_file);
    reset(f2);
    assign(f,write_file);
    rewrite(f);
    while (not eof(f2)) do
      begin
        readln(f2,s);
        p:=pos(' ',s);
        action:=copy(s,1,p-1);
        if (p=0)
        then
          begin
            action:=s;
          end;
        parametr_string:=copy(s,p+1,length(s)-p);
        val(parametr_string,parametr,p);
        if (action='push')
        then
          begin
            add(stack,user,parametr,elements_count,f);
          end;
        if (action='pop')
        then
          begin
            delete_element(stack,user,elements_count,f);
          end;
        if (action='clear')
        then
          begin
            clear_stack(stack,user,elements_count,f);
          end;
        if (action='print')
        then
          begin
            print(stack,user,elements_count,f);
          end;
      end;
    close(f2);
    close(f);
  end;
var read_file,write_file:string;
begin
  if (paramstr(1)<>''){᫨  ࠬ  ப}
  then{}
    begin
      read_file:=paramstr(1);{뢠 䠩 -  ࠬ}
      write_file:=paramstr(2);{室 䠩 - ன ࠬ}
      file_interface(read_file,write_file);
    end
  else{᫨ , }
    begin
      user_interface;
    end;
end.